'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _vm = require('vm2');

var _SensorData = require('./SensorData');

var _SensorData2 = _interopRequireDefault(_SensorData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Calibrator = function () {
	function Calibrator() {
		_classCallCheck(this, Calibrator);
	}

	_createClass(Calibrator, [{
		key: 'calibrate',
		value: function calibrate(data) {
			if (!(data instanceof _SensorData2.default)) throw new Error('Invalid SensorData given.');

			data.getAttributes().forEach(function (attr) {
				attr.getCalibrators().forEach(function (calibrator) {
					var vm = new _vm.VM({
						timeout: 1000,
						sandbox: {
							Math: Math,
							val: data.getValue(attr.getName())
						}
					});

					var value = vm.run('(' + calibrator.toString() + ')(val)');

					data.setValue(attr.getName(), value);
				});
			});
		}
	}]);

	return Calibrator;
}();

exports.default = Calibrator;