'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _SensorData = require('./SensorData');

var _SensorData2 = _interopRequireDefault(_SensorData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Converter = function () {
	function Converter(types) {
		_classCallCheck(this, Converter);

		this.setTypes(types || {});
	}

	_createClass(Converter, [{
		key: 'setTypes',
		value: function setTypes(types) {
			this._types = types;
		}
	}, {
		key: 'getTypes',
		value: function getTypes() {
			return this._types;
		}
	}, {
		key: 'setType',
		value: function setType(name, type) {
			this._types[name] = type;
		}
	}, {
		key: 'getType',
		value: function getType(name) {
			return this._types[name];
		}
	}, {
		key: 'convert',
		value: function convert(data) {
			var _this = this;

			if (!(data instanceof _SensorData2.default)) throw new Error('Invalid SensorData given.');

			var attributes = data.getAttributes();
			var context = {
				data: data,
				buffer: data.getBuffer(),
				pointer: 0,
				getType: this.getType.bind(this)
			};

			attributes.forEach(function (attr) {
				attr.getConverters().forEach(function (converter) {
					var fn = _this.getType(converter.type);
					var err;

					if (typeof fn !== 'function') throw new Error('Unsuported converter type: ' + converter.type);

					try {
						err = fn.call(context, attr.getName(), converter.value);

						if (err) throw new Error(err);
					} catch (e) {
						err = e;
						if (err instanceof RangeError) {
							err = new Error('Cannot convert \'' + attr.getName() + '\' (' + converter.type + '): ' + 'Payload too small.');
							err.statusCode = 400;
						}
						throw err;
					}
				});
			});
		}
	}]);

	return Converter;
}();

exports.default = Converter;