'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _util = require('util');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var validDeviceId = /^[a-f0-9]{16}$/;

var SensorData = function () {
	function SensorData(id, buffer) {
		_classCallCheck(this, SensorData);

		this.setData(this.getDefaultData());
		if (id) this.setDeviceId(id);
		if (buffer) this.setBuffer(buffer);
		this.setAttributes([]);
	}

	_createClass(SensorData, [{
		key: 'setDeviceId',
		value: function setDeviceId(id) {
			id = id.toLowerCase();
			if (!id.match(validDeviceId)) return false;
			this._id = id.toLowerCase();
			return true;
		}
	}, {
		key: 'getDeviceId',
		value: function getDeviceId() {
			return this._id;
		}
	}, {
		key: 'setBuffer',
		value: function setBuffer(buffer) {
			if (!Buffer.isBuffer(buffer)) throw new Error('Invalid Buffer given.');
			if (!buffer.length) throw new Error('Empty Buffer given.');
			this._buffer = buffer;
			this.setValue('_raw', buffer.toString('hex'));
		}
	}, {
		key: 'getBuffer',
		value: function getBuffer() {
			return this._buffer;
		}
	}, {
		key: 'setData',
		value: function setData(data) {
			this._data = data;
		}
	}, {
		key: 'getDefaultData',
		value: function getDefaultData() {
			return {
				timestamp: Math.floor(Date.now() / 1000)
			};
		}
	}, {
		key: 'getData',
		value: function getData() {
			return this._data;
		}
	}, {
		key: 'setAttributes',
		value: function setAttributes(attributes) {
			this._attributes = attributes;
		}
	}, {
		key: 'getAttributes',
		value: function getAttributes() {
			return this._attributes;
		}
	}, {
		key: 'setValue',
		value: function setValue(name, val) {
			var data = this.getData();
			data[name] = val;
		}
	}, {
		key: 'getValue',
		value: function getValue(name) {
			return this.getData()[name];
		}
	}, {
		key: 'toString',
		value: function toString() {
			return this.getDeviceId() + ' ' + (0, _util.inspect)(this.getData());
		}
	}]);

	return SensorData;
}();

exports.default = SensorData;