#!/usr/bin/env node
'use strict';

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _Server = require('../Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// CLI
var argv = require('optimist').usage('Configuration driven binary payload processor for\n' + 'Converting, Calibrating, and Validating dynamic sensor data.\n\n' + 'Usage: $0 --config=/path/to/config.js').demand('config').alias('config', 'c').describe('config', 'Path to config.js file').argv;

// Load config
var configFile = _path2.default.resolve(argv.config);

if (!_fs2.default.existsSync(configFile)) {
	console.error('Configuration file does not exist:', configFile);
	process.exit(1);
}

try {
	var config = require(_path2.default.resolve(argv.config));
} catch (ex) {
	console.error('Configuration file cannot be loaded:');
	console.error(ex.toString());
	process.exit(1);
}

// Boostrap server
var server = new _Server2.default();

server.setDebugMode(config.debug).setLogFile(config.logFile).setLogName(config.logName).setPort(config.port).setPayloadMaxSize(config.payloadMaxSize).setAuth(config.auth).setMetadata(config.metadata).setStorage(config.storage);

server.start();